using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_Maestros._0_Modelos;
using Exferia_General;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;
using System.Data.SqlClient;
using System.Threading;

namespace Exferia_Maestros._1_Datos
{
    public class MAE_Articulos_Temporadas_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                   " SELECT " +
                         nameof(MAE_Articulos_Temporadas.id) + "," +
                         nameof(MAE_Articulos_Temporadas.idArticulo) + "," +
                         nameof(MAE_Articulos_Temporadas.desde_Dia) + "," +
                         nameof(MAE_Articulos_Temporadas.desde_Mes) + "," +
                         nameof(MAE_Articulos_Temporadas.hasta_Dia) + "," +
                         nameof(MAE_Articulos_Temporadas.hasta_Mes) + "," +
                         nameof(MAE_Articulos_Temporadas.cantidad_Minima) + "," +
                         nameof(MAE_Articulos_Temporadas.cantidad_Maxima) + "," +
                         nameof(MAE_Articulos_Temporadas.puntoPedido) +
                  " FROM " + nameof(MAE_Articulos_Temporadas) +
                  " WHERE " + nameof(MAE_Articulos_Temporadas.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<MAE_Articulos_Temporadas>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_Temporadas_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        #endregion

        #region Obtener para Listado
        public List<INTERNO_MAE_Articulos_Temporadas_Listado_Modelo> Obtener_Para_Listado_Por_IdArticulo(long _lng_idArticulo)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            List<INTERNO_MAE_Articulos_Temporadas_Listado_Modelo> lst_INTERNO_MAE_Articulos_Temporadas_Listado_Modelo = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                 " SELECT " +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.id) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.id) + "," +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.idArticulo) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.idArticulo) + "," +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.desde_Dia) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.desde_Dia) + "," +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.desde_Mes) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.desde_Mes) + "," +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.hasta_Dia) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.hasta_Dia) + "," +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.hasta_Mes) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.hasta_Mes) + "," +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.cantidad_Minima) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.cantidad_Minima) + "," +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.cantidad_Maxima) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.cantidad_Maxima) + "," +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.puntoPedido) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.puntoPedido) +
                " FROM " + nameof(MAE_Articulos_Temporadas) +
                " WHERE " + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.idArticulo) + "=@idArticulo " +
                " ORDER BY " + nameof(MAE_Articulos_Temporadas.desde_Mes) + " ASC," + nameof(MAE_Articulos_Temporadas.desde_Dia) + " ASC";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idArticulo",  _lng_idArticulo)
                };

                //Rellenar el Modelo
                lst_INTERNO_MAE_Articulos_Temporadas_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MAE_Articulos_Temporadas_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_Temporadas_Datos) + "/" + nameof(Obtener_Para_Listado_Por_IdArticulo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return lst_INTERNO_MAE_Articulos_Temporadas_Listado_Modelo;
        }

        public INTERNO_MAE_Articulos_Temporadas_Listado_Modelo Obtener_Registro_Para_Listado_Por_Id(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_MAE_Articulos_Temporadas_Listado_Modelo mdl_INTERNO_MAE_Articulos_Temporadas_Listado_Modelo = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                 " SELECT " +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.id) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.id) + "," +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.idArticulo) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.idArticulo) + "," +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.desde_Dia) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.desde_Dia) + "," +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.desde_Mes) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.desde_Mes) + "," +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.hasta_Dia) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.hasta_Dia) + "," +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.hasta_Mes) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.hasta_Mes) + "," +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.cantidad_Minima) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.cantidad_Minima) + "," +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.cantidad_Maxima) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.cantidad_Maxima) + "," +
                       nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.puntoPedido) + "=" + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.puntoPedido) +
                " FROM " + nameof(MAE_Articulos_Temporadas) +
                " WHERE " + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                mdl_INTERNO_MAE_Articulos_Temporadas_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MAE_Articulos_Temporadas_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_Temporadas_Datos) + "/" + nameof(Obtener_Registro_Para_Listado_Por_Id), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_MAE_Articulos_Temporadas_Listado_Modelo;
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private MAE_Articulos_Temporadas g_mdl_MAE_Articulos_Temporadas = null;
        public MAE_Articulos_Temporadas Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_Temporadas_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MAE_Articulos_Temporadas;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                               object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_mdl_MAE_Articulos_Temporadas = obj_Exferia_Entities.Database.SqlQuery<MAE_Articulos_Temporadas>(_str_SQL, _arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_Temporadas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Modelo Listado
        private List<MAE_Articulos_Temporadas> g_lst_MAE_Articulos_Temporadas = null;
        public List<MAE_Articulos_Temporadas> Obtener_ModeloListado_Por_IdArticulo(long _lng_idArticulo)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.idArticulo) + "=@idArticulo";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idArticulo",  _lng_idArticulo)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_Temporadas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdArticulo), true);
            }

            return g_lst_MAE_Articulos_Temporadas;
        }
        public List<MAE_Articulos_Temporadas> Obtener_ModeloListado_Por_IdArticulo_SinID(long _lng_idArticulo,long _lng_Id)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " +
                                        nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.id) + "<>@id and " + 
                                        nameof(MAE_Articulos_Temporadas) + "." + nameof(MAE_Articulos_Temporadas.idArticulo) + "=@idArticulo";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_Id),
                     new SqlParameter("@idArticulo",  _lng_idArticulo)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_Temporadas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdArticulo), true);
            }

            return g_lst_MAE_Articulos_Temporadas;
        }

        #region Ejecutar consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                     object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_MAE_Articulos_Temporadas = obj_Exferia_Entities.Database.SqlQuery<MAE_Articulos_Temporadas>(_str_SQL, _arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_Temporadas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(MAE_Articulos_Temporadas.id) + "," +
                    nameof(MAE_Articulos_Temporadas.idArticulo) + "," +
                    nameof(MAE_Articulos_Temporadas.desde_Dia) + "," +
                    nameof(MAE_Articulos_Temporadas.desde_Mes) + "," +
                    nameof(MAE_Articulos_Temporadas.hasta_Dia) + "," +
                    nameof(MAE_Articulos_Temporadas.hasta_Mes) + "," +
                    nameof(MAE_Articulos_Temporadas.cantidad_Minima) + "," +
                    nameof(MAE_Articulos_Temporadas.cantidad_Maxima) + "," +
                    nameof(MAE_Articulos_Temporadas.puntoPedido) +
                " FROM " + nameof(MAE_Articulos_Temporadas);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();

                MAE_Articulos_Temporadas mdl_MAE_Articulos_Temporadas_AGrabar = (MAE_Articulos_Temporadas)_mdl_obj;
                MAE_Articulos_Temporadas mdl_MAE_Articulos_Temporadas_DatosViejos = new MAE_Articulos_Temporadas();

                // Ver si existe ######################################################################
                MAE_Articulos_Temporadas mdl_MAE_Articulos_Temporadas_Final = Obtener_Modelo_Por_Id(mdl_MAE_Articulos_Temporadas_AGrabar.id);
                //#####################################################################################

                //UPDATE
                if (mdl_MAE_Articulos_Temporadas_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_Articulos_Temporadas_Final, mdl_MAE_Articulos_Temporadas_DatosViejos, false, false);

                    //Cargar los Datos Nuevos Del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_Articulos_Temporadas_AGrabar, mdl_MAE_Articulos_Temporadas_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(MAE_Articulos_Temporadas) +
                                            " SET " +
                                                nameof(MAE_Articulos_Temporadas.idArticulo) + "=@idArticulo," +
                                                nameof(MAE_Articulos_Temporadas.desde_Dia) + "=@desde_Dia," +
                                                nameof(MAE_Articulos_Temporadas.desde_Mes) + "=@desde_Mes," +
                                                nameof(MAE_Articulos_Temporadas.hasta_Dia) + "=@hasta_Dia," +
                                                nameof(MAE_Articulos_Temporadas.hasta_Mes) + "=@hasta_Mes," +
                                                nameof(MAE_Articulos_Temporadas.cantidad_Minima) + "=@cantidad_Minima," +
                                                nameof(MAE_Articulos_Temporadas.cantidad_Maxima) + "=@cantidad_Maxima," +
                                                nameof(MAE_Articulos_Temporadas.puntoPedido) + "=@puntoPedido" +
                                            " WHERE " +
                                                nameof(MAE_Articulos_Temporadas.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@idArticulo",  mdl_MAE_Articulos_Temporadas_Final.idArticulo),
                        new SqlParameter("@desde_Dia", mdl_MAE_Articulos_Temporadas_Final.desde_Dia),
                        new SqlParameter("@desde_Mes", mdl_MAE_Articulos_Temporadas_Final.desde_Mes),
                        new SqlParameter("@hasta_Dia", mdl_MAE_Articulos_Temporadas_Final.hasta_Dia),
                        new SqlParameter("@hasta_Mes", mdl_MAE_Articulos_Temporadas_Final.hasta_Mes),
                        mdl_MAE_Articulos_Temporadas_Final.cantidad_Minima != null
                            ?   new SqlParameter("@cantidad_Minima", mdl_MAE_Articulos_Temporadas_Final.cantidad_Minima.Value)
                            :   new SqlParameter("@cantidad_Minima",  DBNull.Value),
                        mdl_MAE_Articulos_Temporadas_Final.cantidad_Maxima != null
                            ?   new SqlParameter("@cantidad_Maxima", mdl_MAE_Articulos_Temporadas_Final.cantidad_Maxima.Value)
                            :   new SqlParameter("@cantidad_Maxima",  DBNull.Value),
                        new SqlParameter("@puntoPedido",  mdl_MAE_Articulos_Temporadas_Final.puntoPedido),
                        new SqlParameter("@id", mdl_MAE_Articulos_Temporadas_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_MAE_Articulos_Temporadas_Final.id;
                }
                //INSERT
                else
                {
                    mdl_MAE_Articulos_Temporadas_Final = new MAE_Articulos_Temporadas();

                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_Articulos_Temporadas_AGrabar, mdl_MAE_Articulos_Temporadas_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(MAE_Articulos_Temporadas) +
                                                " (" +
                                                        nameof(MAE_Articulos_Temporadas.idArticulo) + "," +
                                                        nameof(MAE_Articulos_Temporadas.desde_Dia) + "," +
                                                        nameof(MAE_Articulos_Temporadas.desde_Mes) + "," +
                                                        nameof(MAE_Articulos_Temporadas.hasta_Dia) + "," +
                                                        nameof(MAE_Articulos_Temporadas.hasta_Mes) + "," +
                                                        nameof(MAE_Articulos_Temporadas.cantidad_Minima) + "," +
                                                        nameof(MAE_Articulos_Temporadas.cantidad_Maxima) + "," +
                                                        nameof(MAE_Articulos_Temporadas.puntoPedido) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(MAE_Articulos_Temporadas.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@idArticulo," +
                                                    "@desde_Dia," +
                                                    "@desde_Mes," +
                                                    "@hasta_Dia," +
                                                    "@hasta_Mes," +
                                                    "@cantidad_Minima," +
                                                    "@cantidad_Maxima," +
                                                    "@puntoPedido" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idArticulo",  mdl_MAE_Articulos_Temporadas_Final.idArticulo),
                        new SqlParameter("@desde_Dia", mdl_MAE_Articulos_Temporadas_Final.desde_Dia),
                        new SqlParameter("@desde_Mes", mdl_MAE_Articulos_Temporadas_Final.desde_Mes),
                        new SqlParameter("@hasta_Dia", mdl_MAE_Articulos_Temporadas_Final.hasta_Dia),
                        new SqlParameter("@hasta_Mes", mdl_MAE_Articulos_Temporadas_Final.hasta_Mes),
                        mdl_MAE_Articulos_Temporadas_Final.cantidad_Minima != null
                            ?   new SqlParameter("@cantidad_Minima", mdl_MAE_Articulos_Temporadas_Final.cantidad_Minima.Value)
                            :   new SqlParameter("@cantidad_Minima",  DBNull.Value),
                        mdl_MAE_Articulos_Temporadas_Final.cantidad_Maxima != null
                            ?   new SqlParameter("@cantidad_Maxima", mdl_MAE_Articulos_Temporadas_Final.cantidad_Maxima.Value)
                            :   new SqlParameter("@cantidad_Maxima",  DBNull.Value),
                        new SqlParameter("@puntoPedido",  mdl_MAE_Articulos_Temporadas_Final.puntoPedido)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                //Grabar un registro de trazabilidad con los datos de la trnasaccion realizada
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_Articulos_Temporadas), mdl_MAE_Articulos_Temporadas_DatosViejos, mdl_MAE_Articulos_Temporadas_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_Temporadas_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;


            //Se utiliza la transaccion por la llamada al procedimiento almacenado
            using (TransactionScope transaccion_SQL = new TransactionScope(TransactionScopeOption.Required))
            {
                try
                {
                    obj_Exferia_Entities = new Exferia_Entities();
                    obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                    // Ver si existe ######################################################################
                    MAE_Articulos_Temporadas mdl_MAE_Articulos_Temporadas_Final = Obtener_Modelo_Por_Id(_lng_id);
                    //######################################################################################
                    
                    if(mdl_MAE_Articulos_Temporadas_Final != null)
                    {
                        #region Delete
                        string str_SQL_Delete = " DELETE FROM  " + nameof(MAE_Articulos_Temporadas) +
                                                " WHERE " +
                                                    nameof(MAE_Articulos_Temporadas.id) + "=@id";
                        //Parametros
                        object[] arr_Parametros_Delete = new object[]
                        {
                                new SqlParameter("@id", _lng_id)
                        };
                        #endregion

                        //Delete
                        obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                        //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                        Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_Articulos_Temporadas), null, mdl_MAE_Articulos_Temporadas_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);

                        // Devolver también el Objeto
                        mdl_ValorDevuelto_Modelo.Id = _lng_id;

                        //Se termina la Transaccion Correctamente
                        transaccion_SQL.Complete();
                    }
                }
                catch (Control_Errores)
                {
                    throw;
                }
                catch (Exception ex)
                {
                    throw new Control_Errores("", ex, nameof(MAE_Articulos_Temporadas_Datos) + "/" + nameof(Borrar), true);
                }
                finally
                {
                    obj_Exferia_Entities.Database.Connection.Close();
                    obj_Exferia_Entities.Dispose();

                    transaccion_SQL.Dispose();
                   
                }
            }

            return mdl_ValorDevuelto_Modelo;
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                List<long> lst_idPreciosHistorico = (List<long>)_mdl_obj;

                if (lst_idPreciosHistorico != null && lst_idPreciosHistorico.Count > 0)
                {
                    //Coger los ids y ponerlos de forma que sirva para la consulta
                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(lst_idPreciosHistorico);

                    string str_SQL = " DELETE FROM " + nameof(MAE_Articulos_Temporadas) +
                                     " WHERE " + nameof(MAE_Articulos_Temporadas.id) + " in (" + str_Filtros_IDS + ")";

                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Articulos_Temporadas_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
